function $parcel$defineInteropFlag(a) {
  Object.defineProperty(a, '__esModule', {value: true, configurable: true});
}
function $parcel$export(e, n, v, s) {
  Object.defineProperty(e, n, {get: v, set: s, enumerable: true, configurable: true});
}

$parcel$defineInteropFlag(module.exports);

$parcel$export(module.exports, "default", () => $882b6d93070905b3$export$2e2bcd8739ae039);
/**
 * Returns a function for performing column and/or row-level security on an array of objects.
 *
 * @param data The original dataset (or function producing the dataset) to apply column and/or row-level security to.
 * @param security The predicate functions for column and row-level security.
 * @returns A function that can filter the original dataset given a provided context.
 */ function $882b6d93070905b3$var$crls(data, security = ()=>true) {
    if (typeof data === "function") return async (context)=>{
        const rows = await data();
        return $882b6d93070905b3$var$filterRows(rows, context, security);
    };
    return (context)=>$882b6d93070905b3$var$filterRows(data, context, security);
}
function $882b6d93070905b3$var$filterRows(rows, context, predicate) {
    let filtered = [], i = 0, l = rows.length;
    while(i < l){
        const row = rows[i];
        i++;
        // Evaluate the security predicate for the current row and provided context
        const security = predicate(row, context);
        // If the predicate returns false, exclude the row
        if (security === false) continue;
        // If the predicate returns true, include the row
        if (security === true) {
            filtered.push(row);
            continue;
        }
        let transformed = {}, keys = Object.keys(row), j = 0, m = keys.length;
        while(j < m){
            const col = keys[j], val = row[col];
            // Include the column if the CLS contains the column name
            if (security.has(col)) transformed[col] = val;
            j++;
        }
        // Include the transformed row
        filtered.push(transformed);
    }
    // Return the filtered dataset
    return filtered;
}
var $882b6d93070905b3$export$2e2bcd8739ae039 = $882b6d93070905b3$var$crls;


//# sourceMappingURL=main.js.map
